module transmiter(
    input wire      clock,
    input wire      start,
    input wire[7:0] data,
    
    output reg ready            ,//TODO REMOVE
    output reg out
);
    
    parameter start_bit = 1;
    parameter stop_bit  = 1;

    reg [9:0] _data;
    reg [3:0] _to_transmit;
    
    always @(posedge clock, posedge start)
    begin
        if (start)
        begin
            if (ready)
            begin
                out     <= 0;
                ready   <= 0;
                
                _to_transmit    <= 10;
                _data           <= (start_bit << 9) | (data << 1) | stop_bit; 
            end
        end
        else if (_to_transmit > 0)
        begin
            out <= _data[9];
            
            _to_transmit    <= _to_transmit - 1;
            _data           <= _data << 1;
        end
        else
        begin
            out     <= 0;
            ready   <= 1;
        end
    end 
    
endmodule
